Subject: Re: bug#56607: 29.0.50; (setq auto-resize-tool-bars 'grow-only) has no effect (pgtk)

From: Richard Hansen <[email-masked]>
Date: Sun, 17 Jul 2022 19:37:03 -0400

Eli Zaretskii wrote:
> But I see something suspicious in the code which handles this 
> feature:
> 
>    if (!NILP (Vauto_resize_tool_bars))
>      {
>        bool change_height_p = true;  <<<<<<<<<<<<<<<<<<<<<<
> 
> AFAIU, that initialization should have been to 'false', not 'true'.

Yes, I think you are correct.  The nearly identical code in redisplay_tab_bar has the same problem.

> Can you try this on your system and see if such a change gives good
> results?

Unfortunately, changing it to false had no effect.  gdb didn't find the redisplay_tool_bar symbol, so pgtk builds must define HAVE_EXT_TOOL_BAR.

Lars Ingebrigtsen wrote:
>> The tool bar now shows a ridiculously oversized marine life ring icon 
>> on the "Help" button, and the height of the tool bar has grown to 
>> accommodate the icon's size.
> 
> That sounds like a bug in itself -- I'm not seeing any marine life ring 
> icons at all with --with-pgtk, so I wonder where that is coming from. 
> Do you have a screenshot?

Attached is an animated gif showing the icon and bounce effect.

Po Lu wrote:
> `auto-resize-tool-bars' doesn't work with either of the GTK builds, 
> since tool bars there don't wrap at all, and their dimensions are not 
> under the control of Emacs.

Can the toolbar be nested inside a container widget whose size we can control?

Thanks,
Richard